<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-4" :class="{'has-error': this.errors_planoContas.name}">
                <label>Descrição do pagamento<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.name">
                <label class="error" v-if="this.errors_planoContas.name">{{errors_planoContas.name[0]}}</label>
            </div>

            <div class="form-group col-md-3" :class="{'has-error': this.errors_planoContas.ocorrencia}">
                <label>Ocorrencia <b class="text-danger">*</b></label>
                <select class="form-control" v-model="formData.ocorrencia">
                    <option value="">--Selecione--</option>
                    <option value="Diariamente">Diariamente</option>
                    <option value="Quinzenalmente">Quinzenalmente</option>
                    <option value="Mensalmente">Mensalmente</option>
                    <option value="Bimestralmente">Bimestralmente</option>
                    <option value="Trimestramente">Trimestramente</option>
                    <option value="Semestramente">Semestramente</option>
                    <option value="Anualmente">Anualmente</option>
                </select>
                <label class="error" v-if="this.errors_planoContas.ocorrencia">
                    {{errors_planoContas.ocorrencia[0]}}
                </label>
            </div>

            <div class="form-group col-md-3" :class="{'has-error': this.errors_planoContas.payment_id}">
                <label>Forma de pagamento<b class="text-danger">*</b></label>
                <select class="form-control" v-model='formData.payment_id' v-select2>
                    <option value="">--Selecione--</option>
                    <option v-for="payment in payments" :value="payment.id">
                        {{payment.name}}
                    </option>
                </select>
                <label class="error" v-if="this.errors_planoContas.payment_id">
                    {{errors_planoContas.payment_id[0]}}
                </label>
            </div>

            <div class="form-group col-md-2" :class="{'has-error': this.errors_planoContas.proximo_vencimento}">
                <label>Próximo vencimento<b class="text-danger">*</b></label>
                <input type="date" class="form-control" v-model="formData.proximo_vencimento" mask="11/11/1111">
                <label class="error" v-if="this.errors_planoContas.proximo_vencimento">
                    {{errors_planoContas.proximo_vencimento[0]}}
                </label>
            </div>

            <div class="form-group col-md-3" :class="{'has-error': this.errors_planoContas.saldo}">
                <label>Valor bruto<b class="text-danger">*</b></label>
                <div class="input-group">
                    <div class="input-group-addon">
                        R$
                    </div>
                    <money type="text" class="form-control" v-model="formData.valor"/>
                </div>
                <label class="error" v-if="this.errors_planoContas.valor">{{errors_planoContas.valor[0]}}</label>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        payment_id: '',
                        bank_id: '',
                        centro_custo_id: '',
                        name: '',
                        ocorrencia: '',
                        proximo_vencimento: '',
                        quantas_vezes: '',
                        data_termino: '',
                        quantas: '',
                        valor: 0,
                        situacao: '',
                        observacao: '',
                    }
                }
            }
        },
        data() {
            return {
                errors_planoContas: {
                    payment_id: '',
                    bank_id: '',
                    centro_custo_id: '',
                    name: '',
                    ocorrencia: '',
                    proximo_vencimento: '',
                    quantas_vezes: '',
                    data_termino: '',
                    quantas: '',
                    valor: 0,
                    situacao: '',
                    observacao: '',
                },
                payments: [],
            }
        },

        created() {
            this.loadPayments()
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updatePlanoConta' : 'storePlanoConta'
                const msg = this.isUpdate ? 'Conta bancária editada com sucesso' :
                    'Cadastro de conta bancária feita com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.resetFormData()
                        this.$router.push({name: 'plano-contas'})
                    })
                    .catch((error) => {
                        this.errors_planoContas = error.response.data.errors
                    })
            },

            loadPayments() {
                this.$store.dispatch('loadPayments')
                    .then((response) => {
                        this.payments = response
                    })
            },

            resetFormData() {
                this.formData = {
                    name: '',
                    saldo: ''
                }
            },

            backPage() {
                return this.$router.push({name: 'plano-contas'})
            }
        }
    }
</script>